#define Uses_TResourceFile
#define Uses_Links
#define Uses_fpstream

#define Uses_RefStrCollection
#define Uses_TMenuBar
#define Uses_TStatusLine
#define Uses_TDeskTop
#include "Prog.h"
#include <io.h>
#include <iostream.h>
#include <string.h>

TResourceFile* rez = 0;
// String data is here for easy mod for different language.
const char rezCreating[] 	= "Creating ";
const char rezFail[]		= "Failure creating ";
const char rezWriting[]		= "Writing ";
const char rezDone[]		= " completed.";

RefStrCollection* makeStrings();
TMenuBar* makeMenuBar();
TStatusLine* makeStatusLine();
TDeskTop* makeDeskTop();

// Macro to ease the writing of a resource.
#define WriteResource(a,c)		\
	if( a != 0 ) 				\
		{ 						\
		rez->put( a, c );		\
		TObject::destroy(a);	\
		}

int main()
{
	// Assume the resource is in the parent directory.
	char buf[20];

	strcpy(buf, "..\\");
	strcat(buf, rezName);

	cout << rezCreating << buf << endl;

	// Erase the existing resource file and create a new one.
	unlink(buf);

	fpstream* fs = new fpstream(buf, ios::in|ios::out|ios::binary);
	if(!fs->good())
		{
		cout << rezFail << buf << endl;
		return 2;
		}
	rez = new TResourceFile(fs);

	// Write the strings resource.
	cout << rezWriting << stringsName << endl;
	WriteResource(makeStrings(), stringsName);

	// Write the main menubar.
	cout << rezWriting << rezMenuBar << endl;
	WriteResource(makeMenuBar(), rezMenuBar);

	// Write the main statusline.
	cout << rezWriting << rezStatusLine << endl;
	WriteResource(makeStatusLine(), rezStatusLine);

	// Write the main desktop.
	cout << rezWriting << rezDeskTop << endl;
	WriteResource(makeDeskTop(), rezDeskTop);

	// Do cleanup.
	TObject::destroy(rez);
	rez = 0;

	cout << rezName << rezDone << endl;
	return 0;
}
